/* $Id: scheduler.h,v 1.15 2004/09/27 05:20:57 kamada Exp $ */
/*
 * Copyright (C) 2003, 2004 WIDE Project.
 * All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. Neither the name of the project nor the names of its contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE PROJECT AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE PROJECT OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

struct timeval *scheduler(struct kink_global *kg, struct timeval *tv);
void sched_register(struct kink_handle *kh);
void sched_unregister(struct kink_handle *kh);
void sched_waitnext(struct kink_handle *kh);
void sched_resettimer(struct kink_handle *kh);
void sched_resettimer_custom(struct kink_handle *kh, int sec);

struct kink_handle *sched_get_by_kh(struct kink_global *kg,
    struct kink_handle *rkh);
struct kink_handle *sched_get_by_xid_side(struct kink_global *kg,
    uint32_t xid, int side);
#ifdef CURRENTLY_NOT_USED
struct kink_handle *sched_get_by_xid_side_ph2addr(struct kink_global *kg,
    uint32_t xid, int side, struct sockaddr *src, struct sockaddr *dst);
#endif
struct kink_handle *sched_get_by_xid_side_peer(struct kink_global *kg,
    uint32_t xid, int side, struct kink_peer *peer);
struct kink_handle *sched_get_by_saidx(struct kink_global *kg,
    struct sockaddr *src, struct sockaddr *dst,
    unsigned int proto_id, uint32_t spi);
struct kink_handle *sched_get_by_peer(struct kink_global *kg,
    struct kink_peer *peer);

void print_kink_handles(struct kink_global *kg);
#ifdef DEBUG_THOROUGH_FREE
void cleanup_sched(struct kink_global *kg);
#endif
