/* $Id: utils.h,v 1.16 2004/10/26 09:00:58 kamada Exp $ */
/*
 * Copyright (C) 2003, 2004 WIDE Project.
 * All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. Neither the name of the project nor the names of its contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE PROJECT AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE PROJECT OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */


#define lengthof(array) (sizeof(array) / sizeof((array)[0]))
#define ALIGN(num, al) (((num) + ((al) - 1)) & ~((al) - 1))
#define ALIGN_PTR(ptr, al)						\
	(void *)(((intptr_t)(ptr) + ((al) - 1)) & ~((al) - 1))
#define STR_FN_LINENO(fn, lineno) (fn "(" STRINGIFY(lineno) ")")
#define STRINGIFY(str) #str


/* XXX exitreq is defined in session.c but declared here */
#define EXITREQ_USER		1
#define EXITREQ_NOMEM		2
#define EXITREQ_OTHER		3
extern int exitreq;


#define vmalloc0 vmalloc	/* 0-cleared vmalloc */


#define KLLV_FATAL	0	/* kinkd cannot continue */
#define KLLV_ERR	1
#define KLLV_WARNING	2
#define KLLV_NOTICE	3
#define KLLV_INFO	4
#define KLLV_DEBUG	5

#define KLLV_BASE	3	/* always logging less than or equal to this */

#define kinkd_log(prio, ...)						\
	kinkd_log_x(prio, STR_FN_LINENO(__FILE__, __LINE__),		\
	__VA_ARGS__)
#define kinkd_log_dump(prio, ptr, size)					\
	kinkd_log_dump_x(prio, STR_FN_LINENO(__FILE__, __LINE__),	\
	ptr, size)
#define kinkd_log_flush()						\
	kinkd_log_flush_x(STR_FN_LINENO(__FILE__, __LINE__))

void kinkd_log_x(int prio, const char *loc, const char *fmt, ...);
void kinkd_log_dump_x(int prio, const char *loc, const void *ptr, size_t size);
void kinkd_log_susp(int prio, const char *fmt, ...);
void kinkd_log_dump_susp(int prio, const void *ptr, size_t size);
void kinkd_log_flush_x(const char *loc);


const char *get_myname(const char *argv0);
