/* $Id: pidfile.c,v 1.12 2004/12/20 01:11:20 sakane Exp $ */
/* Copyright (C) 2002 USAGI/WIDE Project.
 * All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. Neither the name of the project nor the names of its contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE PROJECT AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE PROJECT OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

/*
 * Author:       
 *        Mitsuru KANDA  <mk@linux-ipv6.org>
 */
/* from $USAGI_DIR/usagi/dtcp/util.c */
#include "spmd_includes.h"

int
write_pid(char *pidfile, pid_t pid)
{
	int fd;
	char buf[16];

	memset(buf, 0, sizeof(buf));
	while (1) {
		fd = open(pidfile, O_RDWR|O_CREAT|O_EXCL, 0644);
		if (fd >= 0) {
			pid = getpid();
			snprintf(buf, sizeof(buf), "%d", pid);
			write(fd, buf, sizeof(buf));
			close(fd);
			return 0;
		}
		if (errno == EEXIST) { /* file exist */
			fd = open(pidfile, O_RDONLY, 0);
			if (fd < 0) {
				if (errno == ENOENT) { /* just a timing problem. */
					continue;
				}
				break;
			}
			close(fd);
		}
		break;
	}
	return -1;
}

pid_t 
read_pid(char *pidfile)
{
	int fd;
	pid_t pid = -1;
	char buf[16];
	int ret=-1;

	fd = open(pidfile, O_RDONLY, 0644);
	if (fd >= 0) {
		read(fd, buf, sizeof(buf));
		ret = sscanf(buf, "%d", &pid);
		if (ret!=1) return -1;
	}
	close(fd);
	return pid;
}

